/******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "./src/api/Excel.ts":
/*!**************************!*\
  !*** ./src/api/Excel.ts ***!
  \**************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Excel = void 0;
const xvba_com_1 = __webpack_require__(/*! xvba-com */ "xvba-com");
const Sheets_1 = __webpack_require__(/*! ./Sheets */ "./src/api/Sheets.ts");
const WorkBooks_1 = __webpack_require__(/*! ./WorkBooks */ "./src/api/WorkBooks.ts");
class Excel extends xvba_com_1.XvbaCOM {
    constructor() {
        super("Excel.Application");
        this.Visible = () => this.SetBooleanValue("Visible", true);
        this.Name = () => this.GetStrValue("Name");
        this.Quit = () => this.CallMethodToGetVoid("Quit");
        this.WorkBooks = new WorkBooks_1.WorkBooks();
    }
    get Sheets() {
        if (this._Sheets == undefined) {
            this._Sheets = this.CreateObject(Sheets_1.Sheets);
            return this._Sheets;
        }
        else {
            return this._Sheets;
        }
    }
}
exports.Excel = Excel;


/***/ }),

/***/ "./src/api/Sheets.ts":
/*!***************************!*\
  !*** ./src/api/Sheets.ts ***!
  \***************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.Sheets = void 0;
const xvba_com_1 = __webpack_require__(/*! xvba-com */ "xvba-com");
class Sheets extends xvba_com_1.XvbaCOM {
    constructor(param) {
        super(param);
    }
    Count() {
        return this.GetNumbValue("Count");
    }
}
exports.Sheets = Sheets;


/***/ }),

/***/ "./src/api/VBComponent.ts":
/*!********************************!*\
  !*** ./src/api/VBComponent.ts ***!
  \********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.VBComponent = void 0;
const xvba_com_1 = __webpack_require__(/*! xvba-com */ "xvba-com");
class VBComponent extends xvba_com_1.XvbaCOM {
    constructor(param) {
        super(param);
    }
    get Name() {
        if (this._Name == undefined) {
            this._Name = this.GetStrValue("Name");
        }
        return this._Name;
    }
    get Type() {
        if (this._Type == undefined) {
            this._Type = this.GetNumbValue("Type");
        }
        return this._Type;
    }
    Export(compFilePath) {
        return this.CallMethodToGetNumber("Export", compFilePath);
    }
}
exports.VBComponent = VBComponent;


/***/ }),

/***/ "./src/api/VBComponents.ts":
/*!*********************************!*\
  !*** ./src/api/VBComponents.ts ***!
  \*********************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.VBComponents = void 0;
const xvba_com_1 = __webpack_require__(/*! xvba-com */ "xvba-com");
const VBComponent_1 = __webpack_require__(/*! ./VBComponent */ "./src/api/VBComponent.ts");
class VBComponents extends xvba_com_1.XvbaCOM {
    constructor(prop) {
        super(prop);
    }
    get Count() {
        this._Count = this.GetNumbValue("Count");
        return this._Count;
    }
    Item(value) {
        return this.CallMethodToGetObject("Item", VBComponent_1.VBComponent, value);
    }
}
exports.VBComponents = VBComponents;


/***/ }),

/***/ "./src/api/VBProject.ts":
/*!******************************!*\
  !*** ./src/api/VBProject.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.VBProject = void 0;
const xvba_com_1 = __webpack_require__(/*! xvba-com */ "xvba-com");
const VBComponents_1 = __webpack_require__(/*! ./VBComponents */ "./src/api/VBComponents.ts");
class VBProject extends xvba_com_1.XvbaCOM {
    constructor(prop) {
        super(prop);
    }
    get VBComponents() {
        if (this._VBComponents == undefined) {
            this._VBComponents = this.CreateObject(VBComponents_1.VBComponents);
        }
        return this._VBComponents;
    }
}
exports.VBProject = VBProject;


/***/ }),

/***/ "./src/api/WorkBook.ts":
/*!*****************************!*\
  !*** ./src/api/WorkBook.ts ***!
  \*****************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WorkBook = void 0;
const xvba_com_1 = __webpack_require__(/*! xvba-com */ "xvba-com");
const VBProject_1 = __webpack_require__(/*! ./VBProject */ "./src/api/VBProject.ts");
class WorkBook extends xvba_com_1.XvbaCOM {
    constructor(prop) {
        super(prop);
        this.FullName = () => this.GetStrValue("FullName");
    }
    get VBProject() {
        if (this._VBProject == undefined) {
            this._VBProject = this.CreateObject(VBProject_1.VBProject);
            return this._VBProject;
        }
        else {
            return this._VBProject;
        }
    }
    set VBProject(ss) {
        this._VBProject = ss;
    }
    get Activate() {
        return this.GetNumbValue("Activate");
    }
}
exports.WorkBook = WorkBook;


/***/ }),

/***/ "./src/api/WorkBooks.ts":
/*!******************************!*\
  !*** ./src/api/WorkBooks.ts ***!
  \******************************/
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {


Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.WorkBooks = void 0;
const xvba_com_1 = __webpack_require__(/*! xvba-com */ "xvba-com");
const WorkBook_1 = __webpack_require__(/*! ./WorkBook */ "./src/api/WorkBook.ts");
class WorkBooks extends xvba_com_1.XvbaCOM {
    constructor() {
        super();
    }
    /**
     * Open Excel file
     * @param filePath :string
     * @returns
     */
    Open(filePath) {
        return this.CallMethodToGetObject("Open", WorkBook_1.WorkBook, filePath);
    }
}
exports.WorkBooks = WorkBooks;


/***/ }),

/***/ "./src/example/excel.ts":
/*!******************************!*\
  !*** ./src/example/excel.ts ***!
  \******************************/
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.tryExcel = void 0;
const Excel_1 = __webpack_require__(/*! ../api/Excel */ "./src/api/Excel.ts");
const tryExcel = () => __awaiter(void 0, void 0, void 0, function* () {
    try {
        let excel = new Excel_1.Excel();
        excel.Visible();
        let Book = excel.WorkBooks.Open("F:\\Apps\\ExcelXvba\\index.xlsb");
        let sheets = excel.Sheets;
        let total = sheets.Count();
        console.log("--->", total);
        let exName = excel.Name();
        console.log("--->", exName);
        let totalComp = Book.VBProject.VBComponents.Count;
        console.log("--->", totalComp);
        for (let index = 0; index < totalComp; index++) {
            const vbComponent = Book.VBProject.VBComponents.Item(index + 1);
            const compName = vbComponent.Name;
            let compFileName = "";
            switch (vbComponent.Type) {
                case 1:
                    compFileName = compName + ".bas";
                    break;
                case 2:
                    compFileName = compName + ".cls";
                    break;
                case 3:
                    compFileName = compName + ".frm";
                    break;
                case 100:
                    compFileName = compName + ".cls";
                    break;
                default:
                    break;
            }
            const fileExport = "F:\\Apps\\ExcelXvba\\vba\\" + compFileName;
            vbComponent.Export(fileExport);
        }
        excel.Quit();
        Excel_1.Excel.ReleaseAllCOMWithDelay();
    }
    catch (error) {
        console.log(error);
        Excel_1.Excel.ReleaseAllCOMWithDelay();
    }
});
exports.tryExcel = tryExcel;


/***/ }),

/***/ "xvba-com":
/*!***************************!*\
  !*** external "xvba-com" ***!
  \***************************/
/***/ ((module) => {

module.exports = require("xvba-com");

/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
var __webpack_exports__ = {};
// This entry need to be wrapped in an IIFE because it need to be isolated against other modules in the chunk.
(() => {
var exports = __webpack_exports__;
/*!**********************!*\
  !*** ./src/index.ts ***!
  \**********************/

Object.defineProperty(exports, "__esModule", ({ value: true }));
const excel_1 = __webpack_require__(/*! ./example/excel */ "./src/example/excel.ts");
(0, excel_1.tryExcel)();

})();

module.exports = __webpack_exports__;
/******/ })()
;
//# sourceMappingURL=index.js.map